<?php

return [
    /**
     * Options: mysql
     */
    'drivers' => [
        'analytic' => 'mysql',
        'metric' => 'mysql',
    ],

    'cookie' => [
        'name' => 'analytic-user-reference',
        'lifetime' => null,
    ],

    'table-names' => [
        'analytics' => 'analytics',
        'metrics' => 'metrics',
    ],
    'models' => [
        'analytic' => \Drp\Analytics\Models\Analytic::class,
        'metric' => \Drp\Analytics\Models\Metric::class,
    ],

    'queue' => env('ANALYTICS_QUEUE_NAME', 'analytics'),
    'controller' => \Drp\Analytics\Http\Controllers\StoreAnalyticsController::class,
    'route' => [
        'prefix' => '',
        'uri' => 'store',
        'name' => 'analytics.store',
        'middleware' => ['auth:api'],
    ],

    /**
     * Trackers
     *
     * [event => concept]
     *
     * Concepts: analytic, metric
     */
    'trackers' => [
        'button-clicked' => 'analytic',
        'file-downloaded' => 'metric',
    ]
];
