<?php

namespace Drp\Analytics\Jobs;

use Drp\Analytics\Contracts\HandlesAnalytics;
use Drp\Analytics\Foundation\AnalyticPayload;
use Drp\Analytics\Foundation\AnalyticReference;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;

class StoreAnalytic implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    private $handler;

    private $reference;

    private $payload;

    public function __construct(HandlesAnalytics $handler, AnalyticReference $reference, AnalyticPayload $payload)
    {
        $this->handler = $handler;
        $this->reference = $reference;
        $this->payload = $payload;
    }

    public function handle(): void
    {
        $this->handler->store($this->reference, $this->payload);
    }
}
