<?php

namespace Drp\Analytics\Listeners;

use Illuminate\Auth\Events\Login;
use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Support\Facades\Cookie;

class GenerateAnalyticsCookie
{
    public function handle(Login $event): void
    {
        Cookie::queue(config('analytics.cookie.name'), $this->valueFor($event->user), $this->getExpiry());
    }

    private function valueFor(Authenticatable $user): string
    {
        return json_encode([
            'id' => $user->getAuthIdentifier(),
            'type' => get_class($user)
        ]);
    }

    private function getExpiry(): int
    {
        return config('analytics.cookie.lifetime') ?? config('session.lifetime');
    }
}
